
// Steuerung der Fußgängerampel über Interrupts
                   
 int lirot = 12;   // rot : D12   Ampel für Autos
 int ligelb = 10;  // gelb : D10
 int ligruen = 8;  // grün : D8
 int rerot = 13;   // rot : D13  Fußgängerampel
 int regelb = 11;
 int regruen = 9;  // grün : D9
 int taster = 2;   // Fußgängertaster auf interruptfähigem Pin
 int warten = 7;   // Gelbe LED in der Mitte als Signal "Bitte warten"
 int dauer;
 int anforderung=0;
 
  #include "Ampelphasen.h" // hier eingefügt, da Konstanten deklariert sein müssen
 
 void setup() {             // Alle Pins außer Taster als Ausgang programmieren
   pinMode(lirot,OUTPUT);
   pinMode(ligelb,OUTPUT);
   pinMode(ligruen,OUTPUT);
   pinMode(rerot,OUTPUT);
   pinMode(regruen,OUTPUT); 
   pinMode(warten,OUTPUT);

   pinMode(taster,INPUT_PULLUP);       // Taster an D2 steuert Interrupt 0
   attachInterrupt(0,signalKommt,LOW); // LOW startet die Funktion "signalKommt()"
 }

 void signalKommt() {           // wird aufgerufen, sobald Taster gedrückt wird  
   anforderung=1;               // setzt Variable anforderung
   digitalWrite(warten,HIGH);   // schaltet gelbe LED ein "Bitte warten!"
}

 void loop() {
   gruen_rot(10000);            // minimale Grünphase für Hauptrichtung
   if (anforderung == 1) {      // ist 1, falls in dieser Zeit Taster gedrückt wurde
     anforderung=0;
     digitalWrite(warten,LOW);  // setzt "Grün kommt"-LED
     gelb_rot(2000); 
     rot_rot(3000);
     rot_rotgelb(1000);
     rot_gruen(5000);
     if (anforderung == 1) {    // Wenn während Grünphase Taster gedrückt wird, 
       anforderung=0;           // wird Grünphase um 2 Sekunden verlängert
       digitalWrite(warten,LOW); 
       delay(2000); 
     } 
     rot_rot(3000);
     rotgelb_rot(1000);
   } 
 } 
 
 

